title: VIS IWS HK Parameter Chooser
author: M.Whillock@ucl.ac.uk
date: 23 Apr 2020

Copyright © 2020 University College London / MSSL

--


# Introduction


This a mini user guide to the VIS IWS TM HK Parameter Chooser (parameter_chooser.py) program.

## Prerequisites

* python3
* git

## Installation: Online Deployment

TBD

## Installation: Offline Deployment

The parameter chooser is currently bundled in with the TM HK Monitor program.

If this has not alrady been done then choose a location to untar the HKTM_monitor gzipped tar file and untar it.

`tar xvfz HKTM_monitor.tar.gz`


## Parameter Chooser

This program does not require any conda environment to be set.

### Launching
In an xterm change directory to where the program is installed.
This document assumes that python3 is run using the `python` command.
Use whatever command is required to run python3 on your system.

Launch the program:

`python parameter_chooser.py`

The main window will appear:

![parameter_chooser.py main window](Pictures/Parameter_chooser.png)


### Operation

The top-level tab widget with tabs labelled **system** and **packets** allow the user to browse the HK parameters according to the system they refer to or by the HK telemetry packet in which they originate.
These tabs are un-connected with each other: selecting parameters when the **system** tab is selected will not select the corresponding HK parameters in the **packets** tab.
The same principle applies to exporting the selected HK parameters to a file.

#### Parameter Selection And Deselection

A parameter can be selected and de-selected by clicking the mouse in the tick box next to the parameter's name.
Some parameters are place-holders for multiple related HK parameters. This is shown by a disclosure arrow to the left of parameter and it's tick box.

![Disclosure arrows](Pictures/parameter_chooser_arrows.png)

All the parameters related to the place-holder can be selected by clicking the place-holder's tick box.
The related parameters can be revealed by clicking on the disclosure arrow.
Individual parameters in a place-holder group can be selected.
In this case the top tick box will change to a filled box to indicate this.

*Note:* Lines can be highlighted by clicking anywhere in the text. This has no effect on the operation of the program.

![Group selection](Pictures/parameter_chooser_multi.png)

In each sub-tab there are 2 buttons: **Deselect All** and **Select All**.

The **Select All** button will select all the parameters in the currently displayed tab only.


The **Deselect All** button will deselect all the parameters in the currently displayed tab only.


The **Clear All** button below the tab widget will deselect all the parameters in all the sub-tabs of the currently selected main tab (**system** or **packets**) only.
For example, if the **packets** main tab is selected then all the selected parameters in the sub-tabs *RT_FAST*, *RT_SLOW*, etc will be de-selected.
The selected parameters in the sub-tabs of **system** will not be affected.

*NOTE:* A feature of the pyQt5 implementation of tick boxes leads to the situation where after using the **Deselect All** or **Clear All** buttons the place-holder tick box may still be indicating that some sub-parameters are selected (i.e. displaying a filled box). This is not actually the case and pressing the discloure arrow for that parameter will update the display correctly.

No use has yet been discovered for the **Cancel** button.

The **File** menu item is not yet operational.

To quit the program press the **Quit** button.
This will bring up a dialog box confirming the decision to quit.
Pressing **Cancel** in the dialog box will resume the program.
Pressing **Quit** will quit the program.


#### Parameter Export

The selected parameters can be saved to a csv file by clicking on the **Export** button.
Clicking the **Export** button will bring up a standard PyQt5 file save dialog box if there are parameters selected.
This gives the user a chance to navigate to a directory of their choice to save the parameters.
The directory location will be remembered so that the next export of parameters will automatically selected the last used directory.

A valid filename must be entered with the file suffix '.csv'.
If the filename is invalid then an error message box is displayed:

![filetype error](Pictures/parameter_chooser_csverror.png)

If no parameters have been selected then the user is alerted with another error message box:

![no parameters error](Pictures/parameter_chooser_noparameters.png)

All the parameters selected in all the sub-tabs will be exported.
Again, the main tabs are un-connected.
For example, if the **system** main tab is selected then all the selected parameters in the system sub-tabs (*CDPU*, *OBS-G*, etc) will be written to file.

Attempts to export the parameters to an existing file will bring up the standard PyQt5 over-write alert box.

#### Export Format

Currently the parameters are exported in an ASCII text csv format:

`Parameter Name, Parameter MIB Id, Source`

*NOTE:* The source field refers to which packet type the parameter originates from (i.e. rt_fast).

This can easily be adapted for any other future format required.

#### Future Work

- Adapt for multiple export formats with gui format selection.
- Maybe get the **File** menu functionality going.
- Adapt so that new configurations, parameters and windows can be defined for the TM TK Monitor program (it's original purpose in life).
