#!/usr/bin/env python

from PyQt5 import QtWidgets, uic
from pyqtgraph import PlotWidget, plot

import pyqtgraph as pg

import sys, os

class MainWindow(QtWidgets.QMainWindow):

    def __init__(self, *args, **kvargs):
        super(MainWindow, self).__init__(*args, **kvargs)
        self.graphWidget = pg.PlotWidget()
        self.setCentralWidget(self.graphWidget)

        hour = [1,2,3,4,5,6,7,8,9,10]
        temperature1 = [31,32,34,32,33,31,29,32,35,45]
        temperature2 = [31.5,35,30,30,30,31,28,31,34,40]

        self.graphWidget.setBackground('w')
        self.graphWidget.setTitle("Plot Title", color='b', size='150')
        self.graphWidget.setLabel('left', 'Temperature (C)', color='red', size=30)
        self.graphWidget.setLabel('bottom', 'Hours', color='red', size=30)
        self.graphWidget.addLegend()
        self.graphWidget.showGrid(x=True, y=True)
        self.graphWidget.setXRange(0, 10, padding=0)
        self.graphWidget.setYRange(20, 55, padding=0)

        #self.graphWidget.plot(hour, temperature)
        self.plot(hour, temperature1, "Sensor 1", 'r')
        self.plot(hour, temperature2, "Sensor 2", 'b')

    def plot(self, x, y, plotname, color):
        pen = pg.mkPen(color = color)
        self.graphWidget.plot(x, y, name=plotname, pen=pen, symbol='+', symbolSize=10, symbolBrush=(color))

def main():
    app = QtWidgets.QApplication(sys.argv)
    main = MainWindow()
    main.show()
    sys.exit(app.exec_())

if __name__ == '__main__':
    main()
