#!/usr/bin/env python

from PyQt5 import QtWidgets, QtCore, uic
from PyQt5.QtGui import QPainter, QPen
from PyQt5.QtCore import Qt

from pyqtgraph import PlotWidget, plot

import pyqtgraph as pg

import sys, os
from random import randint

class MainWindow(QtWidgets.QMainWindow):

    def __init__(self, *args, **kvargs):
        super(MainWindow, self).__init__(*args, **kvargs)

        self.graphWidget = pg.PlotWidget()
        self.setCentralWidget(self.graphWidget)

        self.x  = list(range(100))
        self.y  = [randint(0, 100) for _ in range(100)]
        self.y1 = [randint(0, 100) for _ in range(100)]

        self.graphWidget.setBackground('w')
        self.graphWidget.setTitle("Plot Title", color='b', size='150')
        self.graphWidget.setLabel('left', 'Temperature (C)', color='red', size=30)
        self.graphWidget.setLabel('bottom', 'Hours', color='red', size=30)
        #self.graphWidget.addLegend()
        self.graphWidget.showGrid(x=True, y=True)
        #self.graphWidget.setXRange(0, 10, padding=0)
        self.graphWidget.setYRange(-20, 120, padding=0)

        pen = pg.mkPen(color = (255, 0, 0))
        self.data_line  = self.graphWidget.plot(self.x, self.y, pen=pen)
        pen = pg.mkPen(color = (0, 0, 255))
        self.data_line1 = self.graphWidget.plot(self.x, self.y1, pen=pen)

        #self.graphWidget.plot(hour, temperature)
        #self.plot(hour, temperature1, "Sensor 1", 'r')
        #self.plot(hour, temperature2, "Sensor 2", 'b')

        self.timer = QtCore.QTimer()
        self.timer.setInterval(500)
        self.timer.timeout.connect(self.update_plot)
        self.timer.start()

        painter = QPainter()
        painter.begin(self)
        painter.setRenderHint(QPainter.Antialiasing)
        painter.setPen(QtCore.Qt.red)
        painter.setBrush(QtCore.Qt.white)
        painter.drawLine(0, 0, 200, 200)

    def update_plot(self):
        self.x = self.x[1:] # Remove the first y element
        self.x.append(self.x[-1] + 1) # Add a new value higher than the last
        self.y = self.y[1:] # Remove the first
        self.y.append(randint(0, 100)) # Add a new random value
        self.y1 = self.y1[1:] # Remove the first
        self.y1.append(randint(0, 100)) # Add a new random value

        self.data_line.setData(self.x, self.y) # Update the data
        self.data_line1.setData(self.x, self.y1) # Update the data

    def plot(self, x, y, plotname, color):
        pen = pg.mkPen(color = color)
        self.graphWidget.plot(x, y, name=plotname, pen=pen, symbol='+', symbolSize=10, symbolBrush=(color))

def main():
    app = QtWidgets.QApplication(sys.argv)
    main = MainWindow()
    main.show()
    sys.exit(app.exec_())

if __name__ == '__main__':
    main()
